;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Erstellung einer LANGEN liste

(define Mll
  (lambda (wert)
    (Make-lange-liste wert)))

(define Make-lange-liste
  (lambda (wert)
    (lgn-lst wert 0 wert)
    ))

(define lgn-lst
  (lambda (wert j i)
    (cond
      [(eq? i 0) (cons wert '())]
      [else (cons j (lgn-lst wert (+ j 1) (- i 1)))]
    )))


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Lineare Suche

(define Linear-suche
  (lambda (groesse wert)
    (lin-such (mll groesse) wert)
    ))

(define Lin-such
 (lambda (ls wert)
   (cond
     [(eq? ls '()) "Bitte KEINE leere Liste eingeben." ]
     [(eq? wert '()) "Bitte einen Wert zum Suchen eingeben."]
     [(eq? (car ls) wert) "Best-Case!"]
     [Else
      (Linil-zuch ls wert (listen-lang ls) 1)]
   )))
 
(define Linil-zuch
  (lambda (ls wert i j)
    (cond
      [(eq? ls '()) (list "Das Element wurden nach" j "Schritten nicht gefunden")]
      [(eq? (car ls) wert) (list "das Element wurde nach" j "Schritten gefunden")]
      [(eq? i 0) (list "Das Element wurden nach" j "Schritten nicht gefunden")]
      [else 
       (Linil-zuch (cdr ls) wert (- i 1) (+ j 1))])))



;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; Binre Suche



(define not-list?
  (lambda wert
    (cond
     [(list? wert) '#f]
     [else '#t])))

;;;;;ermitteln der Lnge einer Liste
(define list-lalng1
         (lambda (ls i)
           (cond
             [(not-list? ls)(+ i 1)]
             [else (list-lalng (cdr ls) (+ i 1))])))

(define list-lalng
         (lambda (ls i)
           (cond
             [(eq? ls '()) i]
          ;   [number? ls i]
             [else (list-lalng (cdr ls) (+ i 1))]))) 

(define listen-lang 
  (lambda (ls)
    (list-lalng ls 0)))

;;;;;Ermitteln der linken 50% Liste   LLL
(define liste-l
  (lambda (ls)
    (list-linkses ls (/ (listen-lang ls) 2))))


(define list-linkses
  (lambda (ls laenge)
    (cond
      [(< laenge 1) '() ]
      [else (cons (car ls) (list-linkses (cdr ls) (- laenge 1)))])))

;;;;;Ermitteln der rechten 50% Liste   RRR
(define liste-ra
  (lambda (ls)
    (list-rechtest ls (modulo (listen-lang ls) 2))))

(define liste-r
  (lambda (ls)
    (list-rechtest ls (/ (listen-lang ls) 2))))

(define list-rechtest
  (lambda (ls laenge)
    (cond
      [(< laenge 1) ls]
      [else (list-rechtest (cdr ls) (- laenge 1))])))

;;;;;BinreSuche
   
;Konzeptionel    
(define ist-er-es
  (lambda (ls wert)
    (cond
      [(eq? ls '()) 'no]
      [(eq? (car ls) wert) (car ls)]
      [else (ist-er-es (cdr ls) wert)]
      )))
;paar-durchsuchung
;isers1 wird nicht genutzt
(define isers1
  (lambda (ls wert)
    (cond
      [(eq? ls '()) 'no]
      [(eq? (car ls) wert) (car ls)]
      [(eq? (cadr ls) wert) (cadr ls)]
      [else 'no]
      )))

(define isers
  (lambda (ls wert k)
    (cond
      [(eq? ls '()) "unter Umstnden ist ein Fehler aufgetreten! Die End-Liste ist leer!!!"]
      [(eq? (car ls) wert) (list "Wert gefunden nach" k "Schritten" )]; fr bint-suc i = 2
      [(eq? (cadr ls) wert) ( list "Wert gefunden nach" k "Schritten" )]; fr bint-suc i = 2
      [(eq? (caddr ls) wert) (list "Wert gefunden nach" k "Schritten")]; fr bint-suc i = 3(!!!! Wichtig ansonsten entsteht eine endlose sich selbst verarbeitende Schleife in bin-suc im falle das die vorletzte Teil Liste eine 3-er liste ist)
      [else "Wert nicht Enthalten"]
      )))

;;;;;Binr Such Maske mit sicherheits abfragen
(define Binaer-suche
  (lambda (groesse wert)
    (bin-such (mll groesse) wert)))

(define bin-such
  (lambda (ls wert)
    (cond
      [(number? wert)
    (cond
      [(eq? ls '()) "Fehler! Eingegebene Liste ist leer"]
      [(eq? wert '()) "Fehler! Eingegebener Wert ist leer"]
      [(list? wert) "Fehler! Der zusuchende Wert soll eine Liste sein!?!"]
      [(eq? (cdr ls) '()) 
       (cond
        [(eq? (car ls) wert) (list "Element nach 1 Schritten gefunden (Best Case)")]
        [else "Element Nicht vorhanden + Liste besteht aus max einem Wert."])]
      [else (bint-suc (sort < ls) wert (listen-lang ls) 0 )])]
      [Else "Ausschlielich Zahlen sind als Suchabfrage erlaubt."])))

;ls = Liste
;wert = gesuchter Wert
;i = lnge der liste
;;;tatschlicher binr Sucher
;wenn die unterste teilliste eine Linke-Liste ist entsteht ein Fehler!

(define bint-suc
  (lambda (ls wert i k)
    (cond
      [(eq? i 2)(isers ls wert k)]
      [(eq? i 3)(isers ls wert k)]
      [(< wert (car (liste-r ls))) 
       (bint-suc (liste-l ls) wert (listen-lang (liste-l ls)) (+ k 1) )
       ]
      [(>= wert (car (liste-r ls))) 
       (bint-suc (liste-r ls) wert (listen-lang (liste-r ls)) (+ k 1))
       ]
      )))
     

(define sort
  (lambda (rel ls)
    (cond 
      [(eq? '() ls)'()]
      [(eq? '() (cdr ls)) ls]
      [(Cond
        [(eq? rel <)(einf < (sort rel (cdr ls))(car ls) )]
        [(eq? rel >)(einf > (sort rel (cdr ls))(car ls) )]
        [else "Relation unzulssig!"])])))

(define einf
  (lambda (relatio ls wawert)
    (cond
      [(eq? ls '())(list wawert)]
      ;[(eq? wawert (car ls) ) (cons sortls wawert)]
      [(relatio wawert (car ls))(cons wawert ls)]
      [else (cons (car ls)(einf relatio (cdr ls) wawert))])))


;;;;; TESTLISTEN ;;;;;
;testliste "d" mit lnge 18
(define d
  '(93 2 96 4 86 5 6 3 34 7 38 45 3333 44 87 10 23 18))
;testliste "c" mit lnge 19
(define c
  '(93 2 96 4 86 5 6 3 34 7 38 45 3333 44 87 10 23 53 19))
;testliste "c" mit lnge 19
(define c2
  '(93 2 245 4 86 5 6 3 34 7 38 45 3333 44 87 10 23 53 19))
;testliste "b" mit lnge 20
(define b
  '(93 2 96 4 86 5 6 3 34 7 38 45 3333 44 87 10 23 53 233 20))
;testliste "b2" mit lnge 20
(define b2
  '(91 2 96 4 86 5 6 3 34 7 38 45 3333 44 87 10 23 53 233 20))
;testliste "a" mit lnge 21
(define a
  '(93 2 96 4 86 5 6 3 34 7 38 45 3333 44 87 10 23 53 233 17 21))
;testliste "z" mit lnge 23
(define z
  '(93 2 4 86 5 6 3 34 7 38 45 3333 44 87 10 27 53 233 17 25 102 23))
;genervt-von-unlogischen-Fehlern-sei-testliste "t" mit lnge 20
(define t
  '(1 1 96 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 233 1))



"Lineare Suche: (Linear-suche <Lnge der Liste> <gesuchter Wert>)"
"Binre Suche:  (Binaer-suche <Lnge der Liste> <gesuchter wert>)"
"fr eine automatisch gefertigte Liste: (Mll <lnge der Liste>)"